/* timer2.h - Abstracts timer2 into a class
 * Copyright (C) 2010 Antoine Mercier-Linteau
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef TIMER2_H_
#define TIMER2_H_

#include <stdint.h>
#include <avr/interrupt.h>

//This will give use a period of 8ms precisely
#define TIMER2_PRESCALER 256
#define TIMER2_OUTPUT_COMPARE 250
#define MS_TO_TIMER2_OVERFLOW 4//1000 / (F_CPU /(TIMER2_PRESCALER * TIMER2_OUTPUT_COMPARE))

static volatile uint64_t milliseconds;

class Timer2
{

	public:
		static void init(void);
		static uint64_t millis(void);

};

#endif /* TIMER2_H_ */
