/* keypad.cpp - abstracts a keypad into a class
 * Copyright (C) 2010 Antoine Mercier-Linteau
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef KEYPAD_H_
#define KEYPAD_H_

#include "stdint.h"

#define DEBOUNCE_MS 50

typedef struct
{
	#define BOUNCING _BV(2)
	#define READ _BV(1)
	#define STATE _BV(0)
	#define UP 1
	#define DOWN 0

	uint8_t state;
	uint32_t debounce;
} key;

class Keypad
{

	public:
		key keys[12];

		//events
		uint8_t keys_up;
		uint8_t keys_down;
		bool keys_bouncing;

	public:
		Keypad();

		uint8_t available();
		//unsigned char available_up();
		uint8_t available_down();
		uint8_t read_up();
		uint8_t read_down();
		void scan();
};

#endif /* KEYPAD_H_ */
