/* packetizer.cpp - turns key presses into packets
 * Copyright (C) 2010 Antoine Mercier-Linteau
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "packetizer.h"
#include <avr/io.h>

Packetizer::Packetizer()
{

	PORTB |= _BV(PORTB0) + _BV(PORTB1);
	DDRB &=  ~(_BV(DDB0) + _BV(DDB1));

	tx_id = (~PINB & 0x03) + 1;

	//Turn-off pull-up so pin does not source current
	PORTB |= ~(_BV(PORTB0) + _BV(PORTB1));

}

void Packetizer::make(uint8_t nbids, packet* p)
{
	current = p;
	current->len = sizeof(packet) + nbids;
	current->txid = tx_id;
	position = nbids;
}
void Packetizer::take(uint8_t key)
{
	if(position)
	{
		*((uint8_t*)((uint16_t)current + sizeof(packet) + position - 1)) = key;
		position--;
	}
}

