/* packetizer.h - turns key presses into packets
 * Copyright (C) 2010 Antoine Mercier-Linteau
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef KEYMOTE_H_
#define KEYMOTE_H_

#include <stdint.h>

struct packet
{
	uint8_t len;
	uint8_t txid;
};

class Packetizer
{
	private:
		uint8_t tx_id;

		packet* current;
		uint8_t position;

	public:
		Packetizer();

		void make(uint8_t size, packet* p);
		void take(uint8_t key);

};

#endif /* KEYMOTE_H_ */
