/* timer0.cpp - abstracts timer0 into a class
 * Copyright (C) 2010 Antoine Mercier-Linteau
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef TIMER0_H_
#define TIMER0_H_

#include <avr/interrupt.h>

#undef DEBUG
//This will give us a period of 16ms precisely
#define TIMER0_PRESCALER 1024
#define TIMER0_OUTPUT_COMPARE 125
//#define MS_TO_TIMER0_OVERFLOW (1000 / (F_CPU /(TIMER0_PRESCALER * TIMER0_OUTPUT_COMPARE)))
#define MS_TO_TIMER0_OVERFLOW 16
static volatile uint32_t milliseconds;

class Timer0
{

	public:

		static void init(void);
		static uint32_t millis(void);

};

#endif /* TIMER0_H_ */
